=== debian/control ===
Source: glite-lb-server
Priority: extra
Maintainer: CESNET Product Teams <emi-lb@metacentrum.cz>
Uploaders: František Dvořák <valtri@civ.zcu.cz>
Build-Depends: debhelper (>= 7.0.50~), bison, flex, glite-lb-types, glite-lb-ws-interface, gsoap, libc-ares-dev, libclassad-dev, libcppunit-dev, libexpat1-dev, libglite-jobid-api-c-dev, libglite-lb-common-dev, libglite-lb-state-machine-dev, libglite-lbjp-common-db-dev, libglite-lbjp-common-gss-dev, libglite-lbjp-common-gsoap-plugin-dev, libglite-lbjp-common-log-dev, libglite-lbjp-common-maildir-dev, libglite-lbjp-common-server-bones-dev, libglite-lbjp-common-trio-dev, libgridsite-dev, libtool-bin, libxml2-dev, lsb-base (>= 3.2-14), pkg-config, voms-dev
# gssapi.h is needed explicitly for glite-lb-server, but the proper package is
# known only in libglite-lbjp-common-gss-dev:
#  - gssapi from Globus (libglobus-gssapi-gsi-dev)
#  - gssapi from MIT Kerberos (libkrb5-dev)
#  - gssapi from Heimdal Kerberos (heimdal-dev)
#Build-Depends: libglobus-gssapi-gsi-dev
Standards-Version: 3.9.1
Section: misc
Homepage: http://glite.cern.ch

Package: glite-lb-server
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, mysql-server, glite-lb-client-progs, glite-lb-utils, glite-lbjp-common-log, adduser
Description: gLite Logging and Bookkeeping server
 glite-lb-server is the gLite Logging and Bookkeeping server. This package
 contains the L&B server daemon (glite-lb-bkserverd) and a tool for rebuilding
 server indices
 (glite-lb-bkindex).

Package: glite-lb-server-dbg
Section: debug
Architecture: any
Depends: glite-lb-server (= ${binary:Version}), ${misc:Depends}
Description: Debugging symbols for gLite L&B server
 glite-lb-server is the gLite Logging and Bookkeeping server. This package
 contains the L&B server daemon (glite-lb-bkserverd) and a tool for rebuilding
 server indices
 (glite-lb-bkindex).
 .
 This package contains debugging symbols for gLite L&B server.
