=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1
-include /usr/share/dpkg/buildflags.mk

p_base=glite-lb-server
p_dbg=glite-lb-server-dbg

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1

# condor classads requires 2011 ISO C++ standard since Debian 8 jessie
classad_version=$(shell dpkg-query -W libclassad0-dev libclassad-dev | cut -f2)
classad_cxxflags=$(shell if dpkg --compare-versions $(classad_version) '>=' '8'; then echo '-std=c++11'; fi)

%:
	dh $@ --parallel --fail-missing

override_dh_auto_configure: config.status
config.status:
	./configure --root=/ --prefix=/usr --libdir=lib --docdir=/usr/share/doc/$(p_base) --mysqlconfdir=/etc/mysql/conf.d --sysdefaultdir=/etc/default --os-type=debian --project=emi

override_dh_auto_build:
	CXXFLAGS="$(CXXFLAGS) $(classad_cxxflags)" dh_auto_build --parallel

override_dh_auto_clean: config.status
	make clean

override_dh_clean:
	dh_clean
	rm -vf Makefile.inc config.status *.spec
	rm -vf debian/glite-lb-bkserverd.init

override_dh_strip:
	dh_strip --dbg-package=$(p_dbg)

override_dh_auto_install:
	dh_auto_install
	rm -vf debian/tmp/usr/lib/*.la
	rm -vf debian/tmp/usr/lib/*.a
	rm -rvf debian/tmp/etc/init.d
	mkdir -p debian/$(p_base)/usr/share/doc
	mv debian/tmp/usr/share/doc/$(p_base) debian/$(p_base)/usr/share/doc/$(p_base)

override_dh_install:
	cp -p config/startup.debian.bkserverd debian/glite-lb-bkserverd.init
	dh_install --fail-missing

override_dh_installdocs:
	dh_installdocs --link-doc=$(p_base)

override_dh_installinit:
	dh_installinit -p$(p_base) --name=glite-lb-bkserverd
