=== debian/watch ===
version=3
http://scientific.zcu.cz/emi/emi.lb.server/glite-lb-server-(.*)\.tar\.gz
